SystemOrganization addCategory: 'OrbeonBPMXpdl_Tests'!

TestCase subclass: #BpmProcessGeneratorTest1
	instanceVariableNames: 'processGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl_Tests'!

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:06'!
activitiesNames1Test
	| taskNames processDefinition |

	taskNames := #('test-case' 'execute-test' 'test-ok' 'analyze-issue-report').
	processDefinition := self getTestCaseProcess.

	(taskNames collect: [:each | processDefinition getTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (taskNames size = processDefinition getNumberOfTasks)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:06'!
activitiesNames2Test
	| taskNames processDefinition |

	taskNames := #('analyze-issue' 'report-fixes' 'internal-test').
	processDefinition := self getFixIssueProcess.

	(taskNames collect: [:each | processDefinition getTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (taskNames size = processDefinition getNumberOfTasks)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:07'!
activitiesNames3Test
	| taskNames processDefinition |

	taskNames := #('analyze-developer-report' 'report-workaround' 'report-solution').
	processDefinition := self getArchitectProcess.

	(taskNames collect: [:each | processDefinition getTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (taskNames size = processDefinition getNumberOfTasks)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:57'!
creationProcessTest

	self assert: self getTestCaseProcess notNil.

	self assert: self getFixIssueProcess notNil.

	self assert: self getArchitectProcess notNil! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:09'!
gatewaysNames1Test
	| gatewaysNames processDefinition |

	gatewaysNames := #('is-issue' 'accept-issue').
	processDefinition := self getTestCaseProcess.

	(gatewaysNames collect: [:each | processDefinition getGatewayNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (gatewaysNames size = processDefinition getNumberOfGateways)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:09'!
gatewaysNames2Test
	| gatewaysNames processDefinition |

	gatewaysNames := #('can fix').
	processDefinition := self getFixIssueProcess.

	(gatewaysNames collect: [:each | processDefinition getGatewayNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (gatewaysNames size = processDefinition getNumberOfGateways)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:10'!
gatewaysNames3Test
	| gatewaysNames processDefinition |

	gatewaysNames := #('has-solution').
	processDefinition := self getArchitectProcess.

	(gatewaysNames collect: [:each | processDefinition getGatewayNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (gatewaysNames size = processDefinition getNumberOfGateways)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:56'!
getArchitectProcess

	^processGenerator getProcessDefinitionNamed: 'architect-process' ifNone: [nil]! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:55'!
getFixIssueProcess

	^processGenerator getProcessDefinitionNamed: 'fix-issue' ifNone: [nil]! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:55'!
getTestCaseProcess

	^processGenerator getProcessDefinitionNamed: 'test-case-process' ifNone: [nil]! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 05:46'!
inTransitions1Test
	| process transition task1 gateway |

	process := self getTestCaseProcess.

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'test-ok' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-finished' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getSubProcessTaskNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 10/30/2015 05:47'!
inTransitions2Test
	| process transition task1 gateway |

	process := self getFixIssueProcess.

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getSubProcessTaskNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 10/30/2015 05:49'!
inTransitions3Test
	| process transition task1 gateway |

	process := self getArchitectProcess.

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 1 inout transitions' stamp: 'BrunoBB 10/30/2015 06:11'!
outTransitions1Test
	| process transition task1 gateway |

	process := self getTestCaseProcess.
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (process startEvent outTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getSubProcessTaskNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 10/30/2015 06:12'!
outTransitions2Test
	| process transition task1 gateway |

	process := self getFixIssueProcess.
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (process startEvent outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getSubProcessTaskNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 10/30/2015 06:13'!
outTransitions3Test
	| process transition task1 gateway |

	process := self getArchitectProcess.
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (process startEvent outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 08:40'!
participantsTest

	self assert: 
		(self getTestCaseProcess participants allSatisfy: [:each | 
			self getFixIssueProcess participants includesIdentical: each]).

	self assert:
		(self getTestCaseProcess participants size = self getFixIssueProcess participants size).

	self assert: 
		(self getTestCaseProcess participants allSatisfy: [:each | 
			self getArchitectProcess participants includesIdentical: each]).

	self assert:
		(self getTestCaseProcess participants size = self getArchitectProcess participants size).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:33'!
rolesResponsibility1Test
	| process tasks gateways subProcessTasks |

	process := self getTestCaseProcess.

	tasks := #('test-case' 'analyze-issue-report').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'test-expert'.
		self assert: isGranted].

	gateways := #('accept-issue').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'test-expert'.
		self assert: isGranted].

	tasks := #('execute-test' 'test-ok').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'tester'.
		self assert: isGranted].

	gateways := #('is-issue').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'tester'.
		self assert: isGranted].

	subProcessTasks := #('fix-issue').
	subProcessTasks do: [:each | | isGranted |
		isGranted := (process getSubProcessTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:33'!
rolesResponsibility2Test
	| process tasks gateways subProcessTasks |

	process := self getFixIssueProcess.

	tasks := #('analyze-issue' 'report-fixes' 'internal-test').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].

	gateways := #('can fix').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].

	subProcessTasks := #('report-to-architect').
	subProcessTasks do: [:each | | isGranted |
		isGranted := (process getSubProcessTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:33'!
rolesResponsibility3Test
	| process tasks gateways |

	process := self getArchitectProcess.

	tasks := #('analyze-developer-report' 'report-solution' 'report-workaround').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'architect'.
		self assert: isGranted].

	gateways := #('has-solution').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'architect'.
		self assert: isGranted].! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:51'!
setUp

	super setUp.

	processGenerator := BpmProcessGenerator exampleGenerator.

	processGenerator generateAllProcess! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:31'!
subProcessesConnectionTest

	self assert: (((self getTestCaseProcess getSubProcessTaskNamed: 'fix-issue' ifNone: [self assert: false]) subProcessDefinition 
							== self getFixIssueProcess)).

	self assert: (((self getFixIssueProcess getSubProcessTaskNamed: 'report-to-architect' ifNone: [self assert: false]) subProcessDefinition == self getArchitectProcess)).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:22'!
transitionAcceptIssueCondition1Test
	| process transition |

	process := self getTestCaseProcess.

	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form acceptOrReject = ''accept'']').


	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form acceptOrReject = ''reject'']')! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:24'!
transitionCanFixCondition2Test
	| process transition |

	process := self getFixIssueProcess.

	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form developerCanFix = ''yes'']').


	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form developerCanFix = ''no'']')! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:27'!
transitionHasSolutionCondition3Test
	| process transition |

	process := self getArchitectProcess.

	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form hasSolution = ''no'']').


	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form hasSolution = ''yes'']')! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:20'!
transitionIsIssueCondition1Test
	| process transition |

	process := self getTestCaseProcess.

	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form result = ''failed'']').


	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form result ~= ''failed'']')! !
